(load "as.scm")

;;; basic tests
(eval (parse '10) '() '() #f)
(eval (parse 'x) (new-env (list 'x) (list 15)) '() #f)
(eval (parse '(+ 1 x)) (new-env (list 'x) (list 15)) '() #f)
(eval (parse '(fun (x y) (+ x y))) (make-empty-env) '() #f)
(eval (parse '(let ((y 10)) (+ y x))) (new-env (list 'x) (list 15)) '() #f)
(eval (parse '(let ((f (fun (x y) (+ x y))))
          (f 3 4))) (make-empty-env) '() #f)


;;testing scoping semantics
(printf "---aspect applies~n")
(eval (parse 
       '(let ((call (fun (f) (fun (jp) (eq-jp? jp f))))
              (open-file (fun (file) (printf "->opening~n"))))
          (let ((apply-to-brussels (fun (f) (f "brussels"))))
            (fluid-around (call open-file)
                          (fun (jp) (printf "trace~n"))
                          (apply-to-brussels open-file))))
       ) (make-empty-env) '() #f)

(printf "---aspect does not apply~n")
(eval (parse 
       '(let ((call (fun (f) (fun (jp) (eq-jp? jp f))))
              (open-file (fun (file) (printf "->opening~n"))))
          (let ((apply-to-brussels (fun (f) (f "brussels"))))
            (around (call open-file) 
                    (fun (jp) (printf "trace~n"))
                    (apply-to-brussels open-file))))
       ) (make-empty-env) '() #f)

(printf "---aspect applies~n")
(eval (parse
       '(let ((call (fun (f) (fun (jp) (eq-jp? jp f))))
              (open-file (fun (file) (printf "->opening~n"))))
            (let ((traced-open (around (call open-file) 
                                       (fun (jp) (printf "trace~n"))
                                       (fun (f) (open-file f)))))
              (traced-open "brussels")))
          ) (make-empty-env) '() #f)

(printf "---aspect does not apply~n")
(eval (parse
       '(let ((call (fun (f) (fun (jp) (eq-jp? jp f))))
              (open-file (fun (file) (printf "->opening~n"))))
          (let ((traced-open (fluid-around (call open-file) 
                                           (fun (jp) (printf "trace~n"))
                                           (fun (f) (open-file f)))))
            (traced-open "brussels")))
       ) (make-empty-env) '() #f)
